Merge pull request #1582 from aledbf/publish-scripts

Add scripts to release from travis-ci
This commit is contained in:
Manuel Alejandro de Brito Fontes 2017-10-25 23:01:00 -03:00 committed by GitHub
commit 65a7f0729b
12 changed files with 359 additions and 61 deletions

View file

@ -13,27 +13,34 @@ go:
go_import_path: k8s.io/ingress-nginx
# New secure variables can be added using travis encrypt -r kubernetes/ingress-nginx --add K=V
env:
global:
- CHANGE_MINIKUBE_NONE_USER=true
- KUBERNETES_VERSION=v1.7.5
- DOCKER=docker
- CHANGE_MINIKUBE_NONE_USER=true
- KUBERNETES_VERSION=v1.7.5
- DOCKER=docker
- secure: LIS2XpZufWTcJ53jiRsSZy2Gi1EUJ1XmLg7z3f2ZHeMnyG2Jhk3GW4vod1FNru+PY4PWgddLdCdIl+jqOYXndFlbdAWF3/Oy5fEkYLXdYV7tdlHcPWDkqNFrfiyZ4guChN+b2Nk6FqU7o5fsZAIR7VAbgqNRF5XMo9Mhn/vhDCQRcnbXy7uq7JTrYUkqDbQoyYvT6b480GCY5gags1zp/xZfPDNZEe936o8i5IPTyiykRyNOXN/AH6kd3pR5e1xYgcvJ9KpSVPghcwFE7kJ4fOVMRhRG5ML+IyML+xD0jX43EMNoqRKZ/HS42kIMCInFbJEcxVde7DPNBZ7Y3GAqh7HO6qrE70Dn3ha6DID6zCoH2ArW39BxG4zempjn2VxYoMRGREyZszWQb++dwGoHmo5FHt6zvIrYBG0dA0H8ja9VkZkjFwtYTGHU1ooPzUfJK4O4VBayV8LqZibyZQR+GrmyQc0aagUY7J/fe4A2PJyI4DbkeZ7GX1ELj0ciDz4urQSzUc8l/T3aU3X+FuJItjgYtMLPmqcjA5uifDCtutE8Z9L2gSpanqUdvLSOozuxPho/KNl+2YlF7fXqPW3LnRf5mHD+NbOff306pvKlHJOb2Vmth+HBQ1XDzt/Cy5+sfwS3E0Vmh6UTq/NtkUXxwH10BDMF7FMVlQ4zdHQvyZ0=
- secure: rKDoy9IYYYy0fYBs4+9mwuBVq/TcxfFwMfE0ywYWhUUdgzrUYSJAwpoe/96EQ4YmESUefwC2nDNq4G3XzJKYOWf83PaIveb9Z//zmMrCQXjDuDBDLpwV3sXSh7evXiVDohJz4ogBCeMRUCMKYsyKBM9yWfa/iu+yI92dbphpK9peOKW6yBc0uspJlln4swN3GS2WT9LVuPY2Azv9U2UqrXufOPDKG/qEb/Vrn4yZ2lR/50r2k45e9nSvDoByvr10V8ubM5Zc0iP0vBuAUVRdByv6N53Q4gaBGapY6SxhIjIPC/h0rNnuT9EXp7MWaPT5FmBxLt9wnyleT9QhZJnFyaBYqFgcz/DKifYQkryY4M5dLMo/Rt3yATyAy8Y0df1TOoV2dKdqwOOwQ8bXB1wDfyrGxmQj9HY4Ffnphx3wPE1a+Sjuh+S5Epm7XJbPx5pZJqNO2hd4sTbk0Xp3gpPbihny2r/jtNwHl0wpFCfOM68RNrsVRlIwG3UhzbZvblbQ/M/mmWCdgzINjt07I2SGCJxfKG0e98Q49SKUoDoOgQTTRDqTC9IgOEDxyfAkT0Vr6BtlP88Nsgnf6kmboyigBrRAiaDQGTxn3SP6LnQI3CeopaRDYvFZe/rTwPXE9XlKoTn9FTWnAqF3MuWaLslDcDKYEh7OaYJjF01piu6g4Nc=
after_success:
- .travis/publish.sh
jobs:
include:
- stage: Static Check
script:
- go get github.com/golang/lint/golint
- make fmt lint vet
- stage: Coverage
script:
- go get github.com/mattn/goveralls
- go get github.com/modocache/gover
- if ! go get github.com/golang/tools/cmd/cover; then go get golang.org/x/tools/cmd/cover; fi
- make cover
- stage: e2e
before_script:
- make e2e-image
- test/e2e/up.sh
script:
- make e2e-test
- stage: Static Check
script:
- go get github.com/golang/lint/golint
- make fmt lint vet
- stage: Coverage
script:
- go get github.com/mattn/goveralls
- go get github.com/modocache/gover
- if ! go get github.com/golang/tools/cmd/cover; then go get golang.org/x/tools/cmd/cover;
fi
- make cover
- stage: e2e
before_script:
- make e2e-image
- test/e2e/up.sh
script:
- make e2e-test

78
.travis/common.sh Executable file
View file

@ -0,0 +1,78 @@
#!/usr/bin/env bash
# Copyright 2017 The Kubernetes Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
if ! [ -z $DEBUG ]; then
set -x
fi
set -o errexit
set -o nounset
set -o pipefail
# Check if jq binary is installed
if ! [ -x "$(command -v jq)" ]; then
echo "Installing jq..."
sudo apt-get install -y jq
fi
if ! [ "$TRAVIS_REPO_SLUG" == "kubernetes/ingress-nginx" ];
then
echo "Only builds from kubernetes/ingress-nginx repository is allowed.";
exit 0;
fi
# variables QUAY_USERNAME and QUAY_PASSWORD are required to push docker images
if [ "$QUAY_USERNAME" == "" ];
then
echo "Environment variable QUAY_USERNAME is missing.";
exit 0;
fi
if [ "$QUAY_PASSWORD" == "" ];
then
echo "Environment variable QUAY_PASSWORD is missing.";
exit 0;
fi
SKIP_MESSAGE="Publication of docker image to quay.io registry skipped."
if ! [ "$TRAVIS_EVENT_TYPE" == "api" ];
then
echo "Only builds triggered from travis-ci API is allowed. $SKIP_MESSAGE";
exit 0;
fi
if ! [ "$TRAVIS_PULL_REQUEST" == "false" ];
then
echo "This is a pull request. $SKIP_MESSAGE";
exit 0;
fi
if ! [ "$TRAVIS_PULL_REQUEST_BRANCH" == "master" ];
then
echo "Only images build from master branch are allowed. $SKIP_MESSAGE";
exit 0;
fi
function docker_tag_exists() {
TAG=${2//\"/}
IMAGES=$(curl -s -H "Authorization: Bearer ${QUAY_PASSWORD}" https://quay.io/api/v1/repository/$1/image/ | jq '.images | sort_by(.sort_index) | .[] .tags | select(.[] !=null) | .[0]' | sed s/\"//g)
if echo "$IMAGES" | grep -q "$TAG" ; then
return 0
fi
return 1
}

29
.travis/ingress-controller.sh Executable file
View file

@ -0,0 +1,29 @@
#!/usr/bin/env bash
# Copyright 2017 The Kubernetes Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
source $DIR/common.sh
IMAGE=$(make -s -C $DIR/../ image-info)
if docker_tag_exists "kubernetes-ingress-controller/nginx-ingress-controller" $(echo $IMAGE | jq .tag); then
echo "Image already published"
exit 0
fi
echo "building kubernetes-ingress-controller/nginx-ingress-controller image..."
make -C $DIR/../ release

29
.travis/nginx-slim.sh Executable file
View file

@ -0,0 +1,29 @@
#!/usr/bin/env bash
# Copyright 2017 The Kubernetes Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
source $DIR/common.sh
IMAGE=$(make -s -C $DIR/../images/nginx-slim image-info)
if docker_tag_exists "kubernetes-ingress-controller/nginx-slim" $(echo $IMAGE | jq .tag); then
echo "Image already published"
exit 0
fi
echo "building nginx-slim image..."
make -C $DIR/../images/nginx-slim release

38
.travis/publish.sh Executable file
View file

@ -0,0 +1,38 @@
#!/usr/bin/env bash
# Copyright 2017 The Kubernetes Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
source $DIR/common.sh
echo "Login to quay.io..."
echo $QUAY_PASSWORD | docker login --username=$QUAY_USERNAME --password-stdin quay.io >/dev/null 2>&1
case "$COMPONENT" in
"ingress-controller")
$DIR/ingress-controller.sh
;;
"ubuntu-slim")
$DIR/ubuntu-slim.sh
;;
"nginx-slim")
$DIR/nginx-slim.sh
;;
*)
echo "Invalid option in environment variable COMPONENT"
exit 1
;;
esac

63
.travis/release-from-travis.sh Executable file
View file

@ -0,0 +1,63 @@
#!/usr/bin/env bash
# Copyright 2017 The Kubernetes Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
if ! [ -z $DEBUG ]; then
set -x
fi
set -o errexit
set -o pipefail
if [ "$TRAVIS_CI_TOKEN" == "" ];
then
echo "Environment variable TRAVIS_CI_TOKEN is missing.";
exit 1;
fi
function publish() {
body=$(cat <<'EOF'
{
"request": {
"branch": "master",
"config": {
"env": {
"COMPONENT": "$2"
}
}
}
}
EOF
)
echo curl -s -X POST \
-H "Content-Type: application/json" \
-H "Accept: application/json" \
-H "Travis-API-Version: 3" \
-H "Authorization: token $1" \
--data "'$body'" \
https://api.travis-ci.org/repo/kubernetes%2Fingress-nginx/requests
}
case "$1" in
ingress-controller|ubuntu-slim|nginx-slim)
publish $TRAVIS_CI_TOKEN $1
;;
*)
echo "Invalid publish option"
exit 1
;;
esac

29
.travis/ubuntu-slim.sh Executable file
View file

@ -0,0 +1,29 @@
#!/usr/bin/env bash
# Copyright 2017 The Kubernetes Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
source $DIR/common.sh
IMAGE=$(make -s -C $DIR/../images/ubuntu-slim image-info)
if docker_tag_exists "kubernetes-ingress-controller/ubuntu-slim" $(echo $IMAGE | jq .tag); then
echo "Image already published"
exit 0
fi
echo "building ubuntu-slim image..."
make -C $DIR/../images/ubuntu-slim release

View file

@ -18,7 +18,7 @@ BUILDTAGS=
# Use the 0.0 tag for testing, it shouldn't clobber any release builds
TAG?=0.9.0-beta.15
REGISTRY?=gcr.io/google_containers
REGISTRY?=quay.io/kubernetes-ingress-controller
GOOS?=linux
DOCKER?=gcloud docker --
SED_I?=sed -i
@ -49,10 +49,10 @@ IMAGE = $(REGISTRY)/$(IMGNAME)
MULTI_ARCH_IMG = $(IMAGE)-$(ARCH)
# Set default base image dynamically for each arch
BASEIMAGE?=gcr.io/google_containers/nginx-slim-$(ARCH):0.27
BASEIMAGE?=quay.io/kubernetes-ingress-controller/nginx-slim-$(ARCH):0.27
ifeq ($(ARCH),arm)
QEMUARCH=arm
QEMUARCH=arm
GOARCH=arm
DUMB_ARCH=armhf
endif
@ -64,14 +64,14 @@ ifeq ($(ARCH),ppc64le)
GOARCH=ppc64le
DUMB_ARCH=ppc64el
endif
#ifeq ($(ARCH),s390x)
# QEMUARCH=s390x
#endif
TEMP_DIR := $(shell mktemp -d)
DOCKERFILE := $(TEMP_DIR)/rootfs/Dockerfile
image-info:
echo -n '{"image":"$(IMAGE)","tag":"$(TAG)"}'
all: all-container
sub-container-%:

View file

@ -4,7 +4,7 @@ BUILDTAGS=
# Use the 0.0 tag for testing, it shouldn't clobber any release builds
TAG?=0.1
REGISTRY?=aledbf
REGISTRY?=quay.io/kubernetes-ingress-controller
GOOS?=linux
DOCKER?=gcloud docker --
SED_I?=sed -i
@ -47,9 +47,6 @@ ifeq ($(ARCH),ppc64le)
QEMUARCH=ppc64le
GOARCH=ppc64le
endif
#ifeq ($(ARCH),s390x)
# QEMUARCH=s390x
#endif
TEMP_DIR := $(shell mktemp -d)

View file

@ -14,8 +14,10 @@
# 0.0.0 shouldn't clobber any released builds
TAG ?= 0.27
REGISTRY ?= gcr.io/google_containers
REGISTRY ?= quay.io/kubernetes-ingress-controller
ARCH ?= $(shell go env GOARCH)
DOCKER ?= gcloud docker --
ALL_ARCH = amd64 arm arm64 ppc64le
SED_I?=sed -i
GOHOSTOS ?= $(shell go env GOHOSTOS)
@ -31,7 +33,7 @@ IMAGE = $(REGISTRY)/$(IMGNAME)
MULTI_ARCH_IMG = $(IMAGE)-$(ARCH)
# Set default base image dynamically for each arch
BASEIMAGE?=gcr.io/google_containers/ubuntu-slim-$(ARCH):0.14
BASEIMAGE?=quay.io/kubernetes-ingress-controller/ubuntu-slim-$(ARCH):0.14
ifeq ($(ARCH),arm)
QEMUARCH=arm
@ -42,13 +44,12 @@ endif
ifeq ($(ARCH),ppc64le)
QEMUARCH=ppc64le
endif
ifeq ($(ARCH),s390x)
QEMUARCH=s390x
endif
TEMP_DIR := $(shell mktemp -d)
image-info:
echo -n '{"image":"$(IMAGE)","tag":"$(TAG)"}'
all: all-container
sub-container-%:
@ -74,25 +75,28 @@ ifeq ($(ARCH),amd64)
else
# When cross-building, only the placeholder "CROSS_BUILD_" should be removed
# Register /usr/bin/qemu-ARCH-static as the handler for ARM binaries in the kernel
docker run --rm --privileged multiarch/qemu-user-static:register --reset
$(DOCKER) run --rm --privileged multiarch/qemu-user-static:register --reset
curl -sSL https://github.com/multiarch/qemu-user-static/releases/download/$(QEMUVERSION)/x86_64_qemu-$(QEMUARCH)-static.tar.gz | tar -xz -C $(TEMP_DIR)
cd $(TEMP_DIR) && $(SED_I) "s/CROSS_BUILD_//g" Dockerfile
endif
docker build -t $(MULTI_ARCH_IMG):$(TAG) $(TEMP_DIR)
$(DOCKER) build -t $(MULTI_ARCH_IMG):$(TAG) $(TEMP_DIR)
ifeq ($(ARCH), amd64)
# This is for to maintain the backward compatibility
docker tag $(MULTI_ARCH_IMG):$(TAG) $(IMAGE):$(TAG)
$(DOCKER) tag $(MULTI_ARCH_IMG):$(TAG) $(IMAGE):$(TAG)
endif
push: .push-$(ARCH)
.push-$(ARCH): .container-$(ARCH)
gcloud docker -- push $(MULTI_ARCH_IMG):$(TAG)
$(DOCKER) push $(MULTI_ARCH_IMG):$(TAG)
ifeq ($(ARCH), amd64)
gcloud docker -- push $(IMAGE):$(TAG)
$(DOCKER) push $(IMAGE):$(TAG)
endif
clean: $(addprefix sub-clean-,$(ALL_ARCH))
sub-clean-%:
docker rmi -f $(IMAGE)-$*:$(TAG) || true
$(DOCKER) rmi -f $(IMAGE)-$*:$(TAG) || true
release: all-container all-push
echo "done"

View file

@ -13,7 +13,7 @@
# limitations under the License.
TAG ?= 0.14
REGISTRY = gcr.io/google_containers
REGISTRY = quay.io/kubernetes-ingress-controller
ARCH ?= $(shell go env GOARCH)
ALL_ARCH = amd64 arm arm64 ppc64le
@ -25,7 +25,7 @@ MULTI_ARCH_IMG = $(IMAGE)-$(ARCH)
BUILD_IMAGE ?= ubuntu-build
TAR_FILE ?= rootfs.tar
PUSH_TOOL ?= gcloud
DOCKER ?= gcloud docker --
# Set default base image dynamically for each arch
ifeq ($(ARCH),amd64)
@ -49,9 +49,11 @@ ifeq ($(ARCH),s390x)
QEMUARCH=s390x
endif
TEMP_DIR := $(shell mktemp -d)
image-info:
echo -n '{"image":"$(IMAGE)","tag":"$(TAG)"}'
all: all-container
sub-container-%:
@ -76,32 +78,35 @@ ifeq ($(ARCH),amd64)
else
# When cross-building, only the placeholder "CROSS_BUILD_" should be removed
# Register /usr/bin/qemu-ARCH-static as the handler for ARM binaries in the kernel
docker run --rm --privileged multiarch/qemu-user-static:register --reset
$(DOCKER) run --rm --privileged multiarch/qemu-user-static:register --reset
curl -sSL https://github.com/multiarch/qemu-user-static/releases/download/$(QEMUVERSION)/x86_64_qemu-$(QEMUARCH)-static.tar.gz | tar -xz -C $(TEMP_DIR)
cd $(TEMP_DIR) && sed -i "s/CROSS_BUILD_//g" Dockerfile.build
endif
docker build --pull -t $(BUILD_IMAGE) -f $(TEMP_DIR)/Dockerfile.build $(TEMP_DIR)
docker create --name $(BUILD_IMAGE) $(BUILD_IMAGE)
docker export $(BUILD_IMAGE) > $(TAR_FILE)
$(DOCKER) build --pull -t $(BUILD_IMAGE) -f $(TEMP_DIR)/Dockerfile.build $(TEMP_DIR)
$(DOCKER) create --name $(BUILD_IMAGE) $(BUILD_IMAGE)
$(DOCKER) export $(BUILD_IMAGE) > $(TAR_FILE)
cp rootfs.tar $(TEMP_DIR)
docker build --pull -t $(MULTI_ARCH_IMG):$(TAG) $(TEMP_DIR)
$(DOCKER) build --pull -t $(MULTI_ARCH_IMG):$(TAG) $(TEMP_DIR)
ifeq ($(ARCH), amd64)
# This is for to maintain the backward compatibility
docker tag $(MULTI_ARCH_IMG):$(TAG) $(IMAGE):$(TAG)
$(DOCKER) tag $(MULTI_ARCH_IMG):$(TAG) $(IMAGE):$(TAG)
endif
push: .push-$(ARCH)
.push-$(ARCH): .container-$(ARCH)
$(PUSH_TOOL) docker -- push $(MULTI_ARCH_IMG):$(TAG)
$(DOCKER) push $(MULTI_ARCH_IMG):$(TAG)
ifeq ($(ARCH),amd64)
$(PUSH_TOOL) docker -- push $(IMAGE):$(TAG)
$(DOCKER) push $(IMAGE):$(TAG)
endif
clean:
docker rmi -f $(IMAGE):$(TAG) || true
docker rmi -f $(BUILD_IMAGE) || true
docker rm -f $(BUILD_IMAGE) || true
$(DOCKER) rmi -f $(IMAGE):$(TAG) || true
$(DOCKER) rmi -f $(BUILD_IMAGE) || true
$(DOCKER) rm -f $(BUILD_IMAGE) || true
rm -f $(TAR_FILE)
release: all-container all-push
echo "done"

View file

@ -14,7 +14,7 @@
# See the License for the specific language governing permissions and
# limitations under the License.
JSONPATH='{range .items[*]}{@.metadata.name}:{range @.status.conditions[*]}{@.type}={@.status};{end}{end}'
export JSONPATH='{range .items[*]}{@.metadata.name}:{range @.status.conditions[*]}{@.type}={@.status};{end}{end}'
echo "downloading kubectl..."
curl -Lo kubectl https://storage.googleapis.com/kubernetes-release/release/$KUBERNETES_VERSION/bin/linux/amd64/kubectl && \
@ -50,12 +50,31 @@ kubectl set image \
deployments \
--namespace ingress-nginx \
--selector app=ingress-nginx \
nginx-ingress-controller=gcr.io/google_containers/nginx-ingress-controller:test
nginx-ingress-controller=quay.io/kubernetes-ingress-controller/nginx-ingress-controller:test
sleep 5
echo "waiting NGINX ingress pod..."
until kubectl get pods -n ingress-nginx -l app=ingress-nginx -o jsonpath="$JSONPATH" 2>&1 | grep -q "Ready=True";
do
sleep 1;
done
function waitForPod() {
until kubectl get pods -n ingress-nginx -l app=ingress-nginx -o jsonpath="$JSONPATH" 2>&1 | grep -q "Ready=True";
do
sleep 1;
done
}
export -f waitForPod
timeout 10s bash -c waitForPod
if kubectl get pods -n ingress-nginx -l app=ingress-nginx -o jsonpath="$JSONPATH" 2>&1 | grep -q "Ready=True";
then
echo "Kubernetes deployments started"
else
echo "Kubernetes deployments with issues:"
kubectl get pods -n ingress-nginx
echo "Reason:"
kubectl describe pods -n ingress-nginx
exit 1
fi